'From Squeak3.10.2 of ''5 June 2008'' [latest update: #7179] on 15 December 2009 at 7:04:18 am'!
Object subclass: #PackageInfo
	instanceVariableNames: 'packageName methodCategoryPrefix postscript preamble preambleOfRemoval postscriptOfRemoval '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PackageInfo-Base'!

!PackageInfo commentStamp: '<historical>' prior: 0!
Subclass this class to create new Packages.!

PackageInfo class
	instanceVariableNames: 'default '!
Object subclass: #PackageList
	instanceVariableNames: 'selectedPackage packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PackageInfo-Base'!

!PackageInfo methodsFor: 'dependencies' stamp: 'ab 6/10/2003 17:18'!
externalClasses
	| myClasses |
	myClasses := self classesAndMetaClasses.
	^ Array streamContents:
		[:s |
		ProtoObject withAllSubclassesDo:
			[:class |
			(myClasses includes: class) ifFalse: [s nextPut: class]]]! !

!PackageInfo methodsFor: 'dependencies' stamp: 'avi 2/29/2004 13:38'!
externalRefsSelect: selBlock thenCollect: colBlock
	| pkgMethods dependents refs extMethods otherClasses otherMethods classNames |

	classNames := self classes collect: [:c | c name].
	extMethods := self extensionMethods collect: [:mr | mr methodSymbol].
	otherClasses := self externalClasses difference: self externalSubclasses.
	otherMethods :=  otherClasses gather: [:c | c selectors].
	pkgMethods := self methods asSet collect: [:mr | mr methodSymbol].
	pkgMethods removeAllFoundIn: otherMethods.

	dependents := Set new.
	otherClasses do: [:c |
		c selectorsAndMethodsDo:
			[:sel :compiled |
			(extMethods includes: sel) ifFalse: 
				[refs := compiled literals select: selBlock thenCollect: colBlock.
				refs do: [:ea |
					((classNames includes: ea) or: [pkgMethods includes: ea])
							ifTrue: [dependents add: (self referenceForMethod: sel ofClass: c) -> ea]]]]].
	^ dependents! !

!PackageInfo methodsFor: 'dependencies' stamp: 'cwp 11/13/2002 00:24'!
externalSubclasses
	| pkgClasses subClasses |
	pkgClasses := self classes.
	subClasses := Set new.
	pkgClasses do: [:c | subClasses addAll: (c allSubclasses)].
	^ subClasses difference: pkgClasses
! !

!PackageInfo methodsFor: 'listing' stamp: 'bf 5/4/2005 16:33'!
allOverridenMethods
	"search classes and meta classes"
	^ Array streamContents: [:stream |
		self allOverridenMethodsDo: [:each | stream nextPut: each]]
! !

!PackageInfo methodsFor: 'listing' stamp: 'ab 12/3/2002 14:38'!
foreignClasses
	| s |
	s := IdentitySet new.
	self foreignSystemCategories
		do: [:c | (SystemOrganization listAtCategoryNamed: c)
				do: [:cl | 
					| cls | 
					cls := Smalltalk at: cl. 
					s add: cls;
					  add: cls class]].
	^ s! !

!PackageInfo methodsFor: 'listing' stamp: 'bf 5/4/2005 17:40'!
overriddenMethods
	^ Array streamContents: [:stream |
		self overriddenMethodsDo: [:each | stream nextPut: each]]
! !

!PackageInfo methodsFor: 'listing' stamp: 'bf 5/4/2005 16:43'!
overriddenMethodsInClass: aClass
	^Array streamContents: [:stream |
		self overriddenMethodsInClass: aClass
			do: [:each | stream nextPut: each]]
! !

!PackageInfo methodsFor: 'listing' stamp: 'nk 5/1/2004 08:40'!
overrideMethods
	^ self extensionMethods select: [:ea | self isOverrideMethod: ea]! !

!PackageInfo methodsFor: 'modifying' stamp: 'avi 10/13/2003 15:40'!
addCoreMethod: aMethodReference
	| category |
	category := self baseCategoryOfMethod: aMethodReference.
	aMethodReference actualClass organization
		classify: aMethodReference methodSymbol
		under: category
		suppressIfDefault: false! !

!PackageInfo methodsFor: 'modifying' stamp: 'avi 10/11/2003 15:17'!
addExtensionMethod: aMethodReference
	| category |
	category := self baseCategoryOfMethod: aMethodReference.
	aMethodReference actualClass organization
		classify: aMethodReference methodSymbol
		under: self methodCategoryPrefix, '-', category! !

!PackageInfo methodsFor: 'modifying' stamp: 'avi 10/13/2003 15:39'!
baseCategoryOfMethod: aMethodReference
	| oldCat oldPrefix tokens | 
	oldCat := aMethodReference category.
	({ 'as yet unclassified'. 'all' } includes: oldCat) ifTrue: [ oldCat := '' ].
	tokens := oldCat findTokens: '*-' keep: '*'.

	"Strip off any old prefixes"
	((tokens at: 1 ifAbsent: [ '' ]) = '*') ifTrue: [
		[ ((tokens at: 1 ifAbsent: [ '' ]) = '*') ]
			whileTrue: [ tokens removeFirst ].
		oldPrefix := tokens removeFirst asLowercase.
		[ (tokens at: 1 ifAbsent: [ '' ]) asLowercase = oldPrefix ]
			whileTrue: [ tokens removeFirst ].
	].

	tokens isEmpty ifTrue: [^ 'as yet unclassified'].
	^ String streamContents:
		[ :s |
		tokens
			do: [ :tok | s nextPutAll: tok ]
			separatedBy: [ s nextPut: $- ]]! !

!PackageInfo methodsFor: 'naming' stamp: 'ab 10/17/2002 00:05'!
categoryName
	|category|
	category := self class category.
	^ (category endsWith: '-Info')
		ifTrue: [category copyUpToLast: $-]
		ifFalse: [category]! !

!PackageInfo methodsFor: 'naming' stamp: 'ab 6/10/2003 17:21'!
methodCategoryPrefix
	^ methodCategoryPrefix ifNil: [methodCategoryPrefix := '*', self packageName asLowercase]! !

!PackageInfo methodsFor: 'naming' stamp: 'ab 10/16/2002 16:57'!
packageName
	^ packageName ifNil: [packageName := self categoryName]! !

!PackageInfo methodsFor: 'naming' stamp: 'ab 10/16/2002 16:56'!
packageName: aString
	packageName := aString! !

!PackageInfo methodsFor: 'testing' stamp: 'nk 4/28/2004 14:20'!
category: categoryName matches: prefix
	| prefixSize catSize |
	categoryName ifNil: [ ^false ].
	catSize := categoryName size.
	prefixSize := prefix size.
	catSize < prefixSize ifTrue: [ ^false ].
	(categoryName findString: prefix startingAt: 1 caseSensitive: false) = 1
		ifFalse: [ ^false ].
	^(categoryName at: prefix size + 1 ifAbsent: [ ^true ]) = $-! !

!PackageInfo methodsFor: 'testing' stamp: 'bf 10/27/2004 13:33'!
changeRecordForOverriddenMethod: aMethodReference
	| position prevPos prevFileIndex preamble tokens sourceFilesCopy stamp method file methodCategory |
	method := aMethodReference actualClass compiledMethodAt: aMethodReference methodSymbol.
	position := method filePosition.
	sourceFilesCopy := SourceFiles collect:
		[:x | x isNil ifTrue: [ nil ]
				ifFalse: [x readOnlyCopy]].
	[method fileIndex == 0 ifTrue: [^ nil].
	file := sourceFilesCopy at: method fileIndex.
	[position notNil & file notNil]
		whileTrue:
		[file position: (0 max: position-150).  "Skip back to before the preamble"
		[file position < (position-1)]  "then pick it up from the front"
			whileTrue: [preamble := file nextChunk].

		"Preamble is likely a linked method preamble, if we're in
			a changes file (not the sources file).  Try to parse it
			for prior source position and file index"
		prevPos := nil.
		stamp := ''.
		(preamble findString: 'methodsFor:' startingAt: 1) > 0
			ifTrue: [tokens := Scanner new scanTokens: preamble]
			ifFalse: [tokens := Array new  "ie cant be back ref"].
		((tokens size between: 7 and: 8)
			and: [(tokens at: tokens size-5) = #methodsFor:])
			ifTrue:
				[(tokens at: tokens size-3) = #stamp:
				ifTrue: ["New format gives change stamp and unified prior pointer"
						stamp := tokens at: tokens size-2.
						prevPos := tokens last.
						prevFileIndex := sourceFilesCopy fileIndexFromSourcePointer: prevPos.
						prevPos := sourceFilesCopy filePositionFromSourcePointer: prevPos]
				ifFalse: ["Old format gives no stamp; prior pointer in two parts"
						prevPos := tokens at: tokens size-2.
						prevFileIndex := tokens last].
				(prevPos = 0 or: [prevFileIndex = 0]) ifTrue: [prevPos := nil]].
		((tokens size between: 5 and: 6)
			and: [(tokens at: tokens size-3) = #methodsFor:])
			ifTrue:
				[(tokens at: tokens size-1) = #stamp:
				ifTrue: ["New format gives change stamp and unified prior pointer"
						stamp := tokens at: tokens size]].
		methodCategory := tokens after: #methodsFor: ifAbsent: ['as yet unclassifed'].
		(self includesMethodCategory: methodCategory ofClass: aMethodReference actualClass) ifTrue:
			[methodCategory = (Smalltalk at: #Categorizer ifAbsent: [Smalltalk at: #ClassOrganizer]) default ifTrue: [methodCategory := methodCategory, ' '].
			^ ChangeRecord new file: file position: position type: #method
						class: aMethodReference classSymbol category: methodCategory meta: aMethodReference classIsMeta stamp: stamp].
		position := prevPos.
		prevPos notNil ifTrue:
			[file := sourceFilesCopy at: prevFileIndex]].
		^ nil]
			ensure: [sourceFilesCopy do: [:x | x notNil ifTrue: [x close]]]
	! !

!PackageInfo methodsFor: 'testing' stamp: 'avi 9/10/2004 18:28'!
extensionMethodsForClass: aClass
	^ (self extensionCategoriesForClass: aClass)
		gather: [:cat | self methodsInCategory: cat ofClass: aClass ]! !

!PackageInfo methodsFor: 'testing' stamp: 'avi 9/14/2004 13:34'!
includesChangeRecord: aChangeRecord
	^ aChangeRecord methodClass notNil and:
		[self
			includesMethodCategory: aChangeRecord category
			ofClass: aChangeRecord methodClass]! !

!PackageInfo methodsFor: 'testing' stamp: 'avi 9/10/2004 18:27'!
isOverrideCategory: aString
	^ aString endsWith: '-override'! !

!PackageInfo methodsFor: 'testing' stamp: 'avi 9/10/2004 18:27'!
isOverrideMethod: aMethodReference
	^ self isOverrideCategory: aMethodReference category! !

!PackageInfo methodsFor: 'testing' stamp: 'avi 9/14/2004 13:35'!
isOverrideOfYourMethod: aMethodReference
	^ (self isYourClassExtension: aMethodReference category) not and:
		[(self changeRecordForOverriddenMethod: aMethodReference) notNil]! !

!PackageInfo methodsFor: 'testing' stamp: 'bf 5/4/2005 16:41'!
methodsInCategory: aString ofClass: aClass 
	^Array streamContents: [:stream |
		self methodsInCategory: aString ofClass: aClass 
			do: [:each | stream nextPut: each]]
! !

!PackageInfo methodsFor: 'testing' stamp: 'bf 5/4/2005 16:44'!
overrideCategoriesForClass: aClass
	^Array streamContents: [:stream |
		self overrideCategoriesForClass: aClass
			do: [:each | stream nextPut: each]]
! !

!PackageInfo methodsFor: 'enumerating' stamp: 'bf 5/4/2005 16:23'!
allOverridenMethodsDo: aBlock
	"search classes and meta classes"
	^ ProtoObject withAllSubclassesDo: [:class | 
		self overriddenMethodsInClass: class do: aBlock]
! !

!PackageInfo methodsFor: 'enumerating' stamp: 'bf 5/4/2005 16:29'!
methodsInCategory: aString ofClass: aClass do: aBlock
	((aClass organization listAtCategoryNamed: aString) ifNil: [^self])
		do: [:sel | aBlock value: (self referenceForMethod: sel ofClass: aClass)]! !

!PackageInfo methodsFor: 'enumerating' stamp: 'bf 5/4/2005 17:39'!
overriddenMethodsDo: aBlock
	^ self allOverridenMethodsDo: [:ea |
		(self isOverrideOfYourMethod: ea)
			ifTrue: [aBlock value: ea]]! !

!PackageInfo methodsFor: 'enumerating' stamp: 'bf 5/4/2005 16:27'!
overriddenMethodsInClass: aClass do: aBlock
	^ self overrideCategoriesForClass: aClass do: [:cat |
		self methodsInCategory: cat ofClass: aClass do: aBlock]! !

!PackageInfo methodsFor: 'enumerating' stamp: 'bf 5/4/2005 16:25'!
overrideCategoriesForClass: aClass do: aBlock
	^ aClass organization categories do: [:cat |
		(self isOverrideCategory: cat) ifTrue: [aBlock value: cat]]! !

!PackageInfo methodsFor: 'preamble/postscript' stamp: 'mist 2/17/2005 22:43'!
hasPostscript

	^ postscript notNil! !

!PackageInfo methodsFor: 'preamble/postscript' stamp: 'mist 2/18/2005 22:43'!
hasPostscriptOfRemoval

	^ postscriptOfRemoval notNil! !

!PackageInfo methodsFor: 'preamble/postscript' stamp: 'mist 2/17/2005 22:39'!
hasPreamble
	^ preamble notNil! !

!PackageInfo methodsFor: 'preamble/postscript' stamp: 'mist 2/18/2005 22:43'!
hasPreambleOfRemoval

	^ preambleOfRemoval notNil! !

!PackageInfo methodsFor: 'preamble/postscript' stamp: 'mist 2/17/2005 12:55'!
name

^ self packageName! !

!PackageInfo methodsFor: 'preamble/postscript' stamp: 'mist 2/18/2005 23:23'!
postscript

^ postscript ifNil: [postscript := StringHolder new contents: '"below, add code to be run after the loading of this package"'].! !

!PackageInfo methodsFor: 'preamble/postscript' stamp: 'mist 2/18/2005 22:44'!
postscript: aString

postscript := StringHolder new contents: aString! !

!PackageInfo methodsFor: 'preamble/postscript' stamp: 'mist 2/17/2005 23:14'!
postscriptOfRemoval

^ postscriptOfRemoval ifNil: [postscriptOfRemoval := StringHolder new contents: '"below, add code to clean up after the unloading of this package"']! !

!PackageInfo methodsFor: 'preamble/postscript' stamp: 'mist 2/18/2005 22:45'!
postscriptOfRemoval: aString

postscriptOfRemoval := StringHolder new contents: aString
! !

!PackageInfo methodsFor: 'preamble/postscript' stamp: 'mist 2/18/2005 23:27'!
preamble

	^ preamble ifNil: [preamble := StringHolder new contents: '"below, add code to be run before the loading of this package"'].
! !

!PackageInfo methodsFor: 'preamble/postscript' stamp: 'mist 2/19/2005 00:37'!
preamble: aString

preamble := StringHolder new contents: aString! !

!PackageInfo methodsFor: 'preamble/postscript' stamp: 'mist 2/17/2005 23:15'!
preambleOfRemoval

^ preambleOfRemoval ifNil: [preambleOfRemoval := StringHolder new contents: '"below, add code to prepare for the unloading of this package"']! !

!PackageInfo methodsFor: 'preamble/postscript' stamp: 'mist 2/19/2005 00:41'!
preambleOfRemoval: aString

preambleOfRemoval := StringHolder new contents: aString
! !


!PackageInfo class methodsFor: 'as yet unclassified' stamp: 'ab 11/14/2002 15:05'!
registerPackage: aString
	"for compatibility with old fileOuts"
	^ Smalltalk at: #FilePackageManager ifPresent: [:p | p registerPackage: aString]! !


!PackageList methodsFor: 'as yet unclassified' stamp: 'avi 10/11/2003 00:18'!
packages
	^ packages ifNil: [packages := self packageOrganizer packages asSortedCollection:
									[:a :b | a packageName <= b packageName]]! !

!PackageList methodsFor: 'actions' stamp: 'rbb 3/1/2005 11:05'!
addPackage
	| packageName |
	packageName := UIManager default request: 'Package name:'.
	packageName isEmpty ifFalse:
		[selectedPackage := self packageOrganizer registerPackageNamed: packageName.
		self changed: #packageSelection]! !

!PackageList methodsFor: 'actions' stamp: 'avi 10/11/2003 00:17'!
packageOrganizer
	^ PackageOrganizer default! !

!PackageList methodsFor: 'actions' stamp: 'avi 10/11/2003 00:24'!
removePackage
	self packageOrganizer unregisterPackage: selectedPackage! !

!PackageList methodsFor: 'actions' stamp: 'avi 10/11/2003 00:23'!
update: aSymbol
	aSymbol = #packages ifTrue:
		[packages := nil.
		self changed: #packageList; changed: #packageSelection]! !

!PackageList methodsFor: 'morphic' stamp: 'avi 10/10/2003 22:37'!
buildList
	^ PluggableListMorph
		on: self
		list: #packageList
		selected: #packageSelection
		changeSelected: #packageSelection:
		menu: #packageMenu:! !

!PackageList methodsFor: 'morphic' stamp: 'avi 2/18/2004 00:28'!
buildWindow
	| window |
	window := SystemWindow labelled: self label.
	window model: self.
	window addMorph: self buildList fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1)).
	^ window! !

!PackageList methodsFor: 'morphic' stamp: 'avi 2/18/2004 00:28'!
defaultBackgroundColor 
	^ Color white! !

!PackageList methodsFor: 'morphic' stamp: 'avi 10/11/2003 00:28'!
defaultExtent
	^ 200@200! !

!PackageList methodsFor: 'morphic' stamp: 'avi 10/10/2003 22:36'!
label
	^ 'Packages'! !

!PackageList methodsFor: 'morphic' stamp: 'avi 10/11/2003 00:24'!
openInWorld
	self packageOrganizer addDependent: self.
	self buildWindow openInWorldExtent: self defaultExtent! !

!PackageList methodsFor: 'morphic' stamp: 'avi 10/11/2003 13:09'!
packageContextMenu: aMenu
	aMenu
		addLine;
		add: 'remove package' action: #removePackage;
		addServices: PackageServices allServices for: selectedPackage extraLines: #()! !

!PackageList methodsFor: 'morphic' stamp: 'avi 10/11/2003 00:10'!
packageList
	^ self packages collect: [:ea | ea packageName]! !

!PackageList methodsFor: 'morphic' stamp: 'avi 10/11/2003 00:24'!
packageMenu: aMenu
	aMenu
		defaultTarget: self;
		add: 'add package' action: #addPackage.
	selectedPackage ifNotNil: [self packageContextMenu: aMenu].
	^ aMenu! !

!PackageList methodsFor: 'morphic' stamp: 'avi 10/10/2003 22:41'!
packageSelection
	^ self packages indexOf: selectedPackage! !

!PackageList methodsFor: 'morphic' stamp: 'avi 10/10/2003 22:41'!
packageSelection: aNumber
	selectedPackage := self packages at: aNumber ifAbsent: [].
	self changed: #packageSelection! !

!PackageList methodsFor: 'morphic' stamp: 'avi 10/11/2003 00:15'!
perform: selector orSendTo: otherTarget
	"Selector was just chosen from a menu by a user.  If can respond, then
perform it on myself. If not, send it to otherTarget, presumably the
editPane from which the menu was invoked."

	(self respondsTo: selector)
		ifTrue: [^ self perform: selector]
		ifFalse: [^ otherTarget perform: selector]! !


!PackageList class methodsFor: 'as yet unclassified' stamp: 'avi 10/11/2003 14:43'!
initialize
	TheWorldMenu registerOpenCommand: {'Package List'. {self. #open}}! !

!PackageList class methodsFor: 'as yet unclassified' stamp: 'avi 10/10/2003 22:38'!
open
	^ self new openInWorld! !


!PackageOrganizer methodsFor: 'initializing' stamp: 'avi 11/12/2003 23:01'!
initialize
	packages := Dictionary new! !

!PackageOrganizer methodsFor: 'searching' stamp: 'nk 6/24/2004 16:02'!
packageOfMethodCategory: categoryName ofClass: aClass
	^self packageOfMethodCategory: categoryName ofClass: aClass ifNone: [ self noPackageFound ]
! !

!PackageOrganizer methodsFor: 'searching' stamp: 'nk 6/24/2004 16:02'!
packageOfMethodCategory: categoryName ofClass: aClass ifNone: errorBlock
	^ self packages detect: [:ea | ea includesMethodCategory: categoryName ofClassNamed: aClass] ifNone: errorBlock
	
	
! !

!PackageOrganizer methodsFor: 'searching' stamp: 'nk 6/24/2004 15:55'!
packageOfSystemCategory: aSystemCategory
	^ self packageOfSystemCategory: aSystemCategory ifNone: [ self noPackageFound ]
! !

!PackageOrganizer methodsFor: 'searching' stamp: 'nk 6/24/2004 15:54'!
packageOfSystemCategory: aSystemCategory ifNone: errorBlock
	^ self packages detect: [:ea | ea includesSystemCategory: aSystemCategory] ifNone: errorBlock
! !


!PackageOrganizer class methodsFor: 'as yet unclassified' stamp: 'avi 10/11/2003 00:17'!
default
	^ default ifNil: [default := self new]! !


!PackageServices class methodsFor: 'as yet unclassified' stamp: 'avi 10/11/2003 12:59'!
initialize
	ServiceClasses := Set new! !


!ReadWriteStream methodsFor: '*packageinfo-base' stamp: 'ab 10/16/2002 15:56'!
untilEnd: aBlock displayingProgress: aString
	aString
		displayProgressAt: Sensor cursorPoint
		from: 0 to: self size
		during:
			[:bar |
			[self atEnd] whileFalse:
				[bar value: self position.
				aBlock value]].! !

PackageServices initialize!
PackageList initialize!
PackageInfo class
	instanceVariableNames: 'default'!
Object subclass: #PackageInfo
	instanceVariableNames: 'packageName methodCategoryPrefix preamble postscript preambleOfRemoval postscriptOfRemoval'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PackageInfo-Base'!
