'From Squeak3.10.2 of ''5 June 2008'' [latest update: #7179] on 15 December 2009 at 7:04:19 am'!
ProtoObject subclass: #TestCoverage
	instanceVariableNames: 'hasRun reference method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnitGUI'!
Object subclass: #TestRunner
	instanceVariableNames: 'categories categoriesSelected classes classesSelected failedList failedSelected errorList errorSelected lastUpdate result classIndex previousRun '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnitGUI'!

!TestRunner commentStamp: '<historical>' prior: 0!
<lint: #ignore rule: #classNotReferenced rational: 'this view is only accessed from menus'>

!


!TestCase class methodsFor: '*sunitgui' stamp: 'lr 4/12/2009 00:27'!
packageNamesUnderTest
	"Answer a collection of package names under test. This is used by the test runner to automatically instrument the code in these packages when checking for test coverage."
	
	^ #()! !


!TestCoverage methodsFor: 'private' stamp: 'lr 3/30/2009 20:26'!
doesNotUnderstand: aMessage
	^ method perform: aMessage selector withArguments: aMessage arguments! !

!TestCoverage methodsFor: 'private' stamp: 'lr 3/30/2009 15:26'!
flushCache! !

!TestCoverage methodsFor: 'private' stamp: 'lr 3/30/2009 15:21'!
mark
	hasRun := true! !

!TestCoverage methodsFor: 'private' stamp: 'lr 3/30/2009 15:27'!
reference
	^ reference! !

!TestCoverage methodsFor: 'testing' stamp: 'lr 3/30/2009 15:09'!
hasRun
	^ hasRun! !

!TestCoverage methodsFor: 'initialization' stamp: 'lr 3/30/2009 15:19'!
initializeOn: aMethodReference
	hasRun := false.
	reference := aMethodReference.
	method := reference compiledMethod! !

!TestCoverage methodsFor: 'actions' stamp: 'lr 3/30/2009 15:20'!
install
	reference actualClass methodDictionary
		at: reference methodSymbol
		put: self! !

!TestCoverage methodsFor: 'actions' stamp: 'lr 3/30/2009 15:31'!
uninstall
	reference actualClass methodDictionary
		at: reference methodSymbol
		put: method! !

!TestCoverage methodsFor: 'evaluation' stamp: 'lr 3/30/2009 15:32'!
run: aSelector with: anArray in: aReceiver
	self mark; uninstall.
	^ aReceiver withArgs: anArray executeMethod: method! !


!TestCoverage class methodsFor: 'instance creation' stamp: 'lr 3/30/2009 15:23'!
on: aMethodReference
	^ self new initializeOn: aMethodReference! !


!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 7/4/2009 15:08'!
filterCategories
	| pattern |
	pattern := UIManager default 
		request: 'Pattern to select categories:' 
		initialAnswer: '*'.
	pattern isNil ifTrue: [ ^ self ].
	categoriesSelected := (categories 
		select: [ :each | pattern match: each ]) asSet.
	self changed: #allSelections; changed: #categorySelected; updateClasses! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 7/4/2009 15:08'!
selectAllCategories
	categoriesSelected := categories asSet.
	self changed: #allSelections; changed: #categorySelected; updateClasses! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 7/4/2009 15:08'!
selectInverseCategories
	categoriesSelected := categories asSet 
		removeAll: categoriesSelected;
		yourself.
	self changed: #allSelections; changed: #categorySelected; updateClasses! !

!TestRunner methodsFor: 'accessing-categories' stamp: 'lr 7/4/2009 15:08'!
selectNoCategories
	categoriesSelected := Set new.
	self changed: #allSelections; changed: #categorySelected; updateClasses! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'lr 1/20/2009 14:49'!
browseClass
	(classes at: classIndex ifAbsent: [ ^ self ]) browse! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'lr 1/20/2009 14:45'!
classMenu: aMenu
	^ aMenu
		title: 'Classes';
		add: 'Browse' action: #browseClass;
		addLine;
		add: 'Select all' action: #selectAllClasses;
		add: 'Select subclasses' action: #selectSubclasses;
		add: 'Select inversion' action: #selectInverseClasses;
		add: 'Select none' action: #selectNoClasses;
		addLine;
		add: 'Filter...' action: #filterClasses;
		addLine;
		add: 'Refresh' action: #updateClasses;
		yourself.! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'lr 1/20/2009 14:46'!
classSelected
	^ classIndex! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'lr 1/20/2009 14:48'!
classSelected: anInteger
	classIndex := anInteger.
	self changed: #classSelected! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'lr 7/4/2009 15:10'!
filterClasses
	| pattern |
	pattern := UIManager default 
		request: 'Pattern to select tests:' 
		initialAnswer: '*'.
	pattern isNil ifTrue: [ ^ self ].
	classesSelected := (classes select: [ :each | 
		pattern match: each name ]) asSet.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'gvc 7/24/2007 12:01'!
selectAllClasses
	"Fixed to update all selections now that the
	selection invalidation has been optimised."
	
	classesSelected := classes asSet.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'gvc 7/24/2007 12:01'!
selectInverseClasses
	"Fixed to update all selections now that the
	selection invalidation has been optimised."
	
	classesSelected := classes asSet 
		removeAll: classesSelected;
		yourself.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'gvc 7/24/2007 11:59'!
selectNoClasses
	"Fixed to update all selections now that the
	selection invalidation has been optimised."
	
	classesSelected := Set new.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!TestRunner methodsFor: 'accessing-classes' stamp: 'gvc 7/24/2007 12:01'!
selectSubclasses
	"Fixed to update all selections now that the
	selection invalidation has been optimised."
	
	| classesForPackages |
	classesForPackages := self findClassesForCategories: categoriesSelected.	
	classesSelected := (classesSelected gather: [ :class |
		class withAllSubclasses select: [ :each |
			classesForPackages includes: each ] ])
		asSet.
	self
		changed: #allSelections;
		changed: #classSelected;
		changed: #hasRunnable! !

!TestRunner methodsFor: 'accessing-testing' stamp: 'jf 3/4/2009 11:59'!
statusColor
	result hasFailures 
		ifTrue:[ ^ Color yellow ].
	result hasErrors 
		ifTrue: [ ^ Color red ].
	^ Color green! !

!TestRunner methodsFor: 'accessing-ui' stamp: 'lr 3/30/2009 14:42'!
buttons
	^ #(( 'Run Selected' #runAll #hasRunnable )
		( 'Run Profiled' #runProfiled #hasRunnable )
		( 'Run Coverage' #runCoverage #hasRunnable )
		( 'Run Failures' #runFailures #hasFailures )
		( 'Run Errors' #runErrors #hasErrors ))! !

!TestRunner methodsFor: 'actions' stamp: 'onierstrasz 5/14/2009 14:05'!
addDeclaredPackagesUnderTestTo: packages 
	classesSelected do: 
		[ :class | 
		(class class selectors includes: #packageNamesUnderTest) ifTrue: 
			[ class packageNamesUnderTest do: [ :name | packages add: (PackageInfo named: name) ] ] ]! !

!TestRunner methodsFor: 'actions' stamp: 'onierstrasz 5/14/2009 14:40'!
addMethodsUnderTestIn: packages to: methods 
	packages
		do: [:package | package isNil
				ifFalse: [package methods
						do: [:method | ((#(#packageNamesUnderTest #classNamesNotUnderTest ) includes: method methodSymbol)
									or: [method compiledMethod isAbstract
											or: [method compiledMethod refersToLiteral: #ignoreForCoverage]])
								ifFalse: [methods add: method]]]]! !

!TestRunner methodsFor: 'actions' stamp: 'onierstrasz 5/14/2009 14:14'!
collectCoverageFor: methods
	| wrappers suite |
	wrappers := methods collect: [ :each | TestCoverage on: each ].
	suite := self
		reset;
		suiteAll.
	
	[ wrappers do: [ :each | each install ].
	[ self runSuite: suite ] ensure: [ wrappers do: [ :each | each uninstall ] ] ] valueUnpreemptively.
	wrappers := wrappers reject: [ :each | each hasRun ].
	wrappers isEmpty 
		ifTrue: 
			[ UIManager default inform: 'Congratulations. Your tests cover all code under analysis.' ]
		ifFalse: 
			[ MessageSet 
				openMessageList: (wrappers collect: [ :each | each reference ])
				name: 'Not Covered Code (' , (100 - (100 * wrappers size // methods size)) printString , '% Code Coverage)' ].
	self saveResultInHistory! !

!TestRunner methodsFor: 'actions' stamp: 'onierstrasz 5/14/2009 16:47'!
excludeClassesNotUnderTestFrom: methods 
	| theClass |
	classesSelected do: 
		[ :class | 
		(class class selectors includes: #classNamesNotUnderTest) ifTrue: 
			[ class classNamesNotUnderTest do: 
				[ :className | 
				theClass := Smalltalk classNamed: className.
				theClass ifNotNil:[
				theClass methods do: 
					[ :each | 
					methods 
						remove: each methodReference
						ifAbsent: [  ] ].
				theClass class methods do: 
					[ :each | 
					methods 
						remove: each methodReference
						ifAbsent: [  ] ]] ] ] ]! !

!TestRunner methodsFor: 'actions' stamp: 'onierstrasz 5/14/2009 14:11'!
promptForPackages
	| packages |
	packages := (PackageOrganizer default packages
				reject: [:package | (package packageName beginsWith: 'Kernel')
						or: [(package packageName beginsWith: 'Collections')
								or: [(package packageName beginsWith: 'Exceptions')
										or: [(package packageName beginsWith: 'SUnit')
												or: [(package packageName beginsWith: 'System')
														or: [package packageName includesSubstring: 'Test' caseSensitive: false]]]]]])
				sort: [:a :b | a packageName < b packageName].
	packages := Array
				with: (UIManager default
						chooseFrom: (packages
								collect: [:package | package packageName])
						values: packages
						title: 'Select Package').
	^ packages! !

!TestRunner methodsFor: 'actions' stamp: 'simon.denier 11/13/2008 19:34'!
runAll
	self reset; runSuite: self suiteAll.
	self saveResultInHistory! !

!TestRunner methodsFor: 'actions' stamp: 'onierstrasz 5/14/2009 14:15'!
runCoverage
	| packages methods |
	packages := Set new.
	self addDeclaredPackagesUnderTestTo: packages.
	packages isEmpty ifTrue: 
		[ packages := self promptForPackages ].
	methods := OrderedCollection new.
	self 
		addMethodsUnderTestIn: packages
		to: methods.
	self excludeClassesNotUnderTestFrom: methods.
	methods isEmpty ifTrue: 
		[ ^ UIManager default inform: 'No methods found for coverage analysis.' ].
	self collectCoverageFor: methods
! !

!TestRunner methodsFor: 'actions' stamp: 'lr 3/30/2009 14:50'!
runSuite: aTestSuite
	self basicRunSuite: aTestSuite do: [ :each | self runTest: each ].
	self updateResults

! !

!TestRunner methodsFor: 'building' stamp: 'lr 10/21/2008 18:04'!
buildErrorListWith: aBuilder
	^ aBuilder pluggableListSpec new
		model: self;
		name: 'Error List';
		list: #errorList; 
		menu: #errorMenu:;
		getIndex: #errorSelected; 
		setIndex: #errorSelected:;
		yourself.! !

!TestRunner methodsFor: 'building' stamp: 'lr 10/21/2008 18:04'!
buildFailureListWith: aBuilder
	^ aBuilder pluggableListSpec new
		model: self;
		name: 'Failure List';
		list: #failedList; 
		menu: #failureMenu:;
		getIndex: #failedSelected; 
		setIndex: #failedSelected:;
		yourself.! !

!TestRunner methodsFor: 'building' stamp: 'lr 10/21/2008 18:05'!
buildStatusWith: aBuilder
	^ aBuilder pluggableInputFieldSpec new
		model: self;
		menu: #statusMenu:;
		color: #statusColor;
		getText: #statusText;
		yourself.! !

!TestRunner methodsFor: 'updating' stamp: 'lr 1/20/2009 14:48'!
updateClasses
	| classesForCategories |
	classesForCategories := self findClassesForCategories: categoriesSelected.
	classes := classesForCategories asArray
		sort: [ :a :b | self sortClass: a before: b ].
	classIndex := 0.
	classesSelected := classesSelected isNil
		ifTrue: [ classesForCategories ]
		ifFalse: [ 
			classesSelected
				select: [ :each | classesForCategories includes: each ] ].
	self changed: #classList; changed: #classSelected; changed: #hasRunnable.! !

!TestRunner methodsFor: 'updating' stamp: 'AlexandreBergel 10/1/2008 23:09'!
updateResults
	"<lint: #expect rule: #guardingClause>"
	"<lint: #expect rule: #longMethods>"

	self updateStatus: false.
	failedList size = result failures size ifFalse: [
		failedList := result failures asArray
			sort: [ :a :b | a printString <= b printString ].
		failedSelected := nil.
		self 
			changed: #failedList; 
			changed: #failedSelected;
			changed: #hasFailures;
			changed: #hasProgress  ].
	errorList size = result errors size ifFalse: [
		errorList := result errors asArray
			sort: [ :a :b | a printString <= b printString ].
		errorSelected := nil.
		self 
			changed: #errorList; 
			changed: #errorSelected;
			changed: #hasErrors;
			changed: #hasProgress ].! !

!TestRunner methodsFor: 'utilities' stamp: 'ar 7/9/2009 14:40'!
findCategories
	| visible |
	visible := Set new.
	self baseClass withAllSubclassesDo: [ :each |
		each category ifNotNilDo: [ :category |
			visible add: category ] ].
	^ Array streamContents: [ :stream |
		Smalltalk organization categories do: [ :each |
			(visible includes: each)
				ifTrue: [ stream nextPut: each ] ] ].! !

!TestRunner methodsFor: 'accessing-menu' stamp: 'lr 10/21/2008 18:10'!
errorMenu: aMenu
	^ self statusMenu: aMenu! !

!TestRunner methodsFor: 'accessing-menu' stamp: 'lr 10/21/2008 18:05'!
failureMenu: aMenu
	^ aMenu! !

!TestRunner methodsFor: 'accessing-menu' stamp: 'simon.denier 11/13/2008 19:43'!
statusMenu: aMenu
	^ aMenu
		add: 'History' action: #showHistoryMenu;
		add: 'Store result as progress reference' action: #storeResultIntoTestCases;
		add: 'Show progress' action: #showProgress; 
		yourself! !

!TestRunner methodsFor: 'history saving' stamp: 'simon.denier 11/13/2008 19:41'!
hasHistory

	self flag: #Useless. "No Senders?"
	^ true! !

!TestRunner methodsFor: 'history saving' stamp: 'simon.denier 11/13/2008 20:28'!
hasProgress

	result classesTested do: [:cls |
		(cls class methodDictionary includesKey: #lastStoredRun)
			ifTrue: [^ true]].
	^ false! !

!TestRunner methodsFor: 'history saving' stamp: 'GwenaelCasaccio 10/1/2008 22:00'!
hasResults

	^ result notNil! !

!TestRunner methodsFor: 'history saving' stamp: 'AlexandreBergel 10/1/2008 12:00'!
historyMenuList
	^ {'** save current result **'}, (self previousRun collect: [:ts | ts printString])! !

!TestRunner methodsFor: 'history saving' stamp: 'AlexandreBergel 10/1/2008 11:46'!
previousRun

	^ previousRun ifNil: [ previousRun := OrderedCollection new ]! !

!TestRunner methodsFor: 'history saving' stamp: 'simon.denier 11/13/2008 19:36'!
saveResultInHistory
	result dispatchResultsIntoHistory! !

!TestRunner methodsFor: 'history saving' stamp: 'AlexandreBergel 10/12/2008 11:55'!
showDiffWith: aTestResult
	| string diff |

	diff := result diff: aTestResult.
	string := String streamContents: [:str|
		str nextPutAll: '----------------'; cr.
		str nextPutAll: 'Diff between current result with: ', aTestResult asString; cr.
		str nextPutAll: 'New passed: '.
		diff first do: [:s| str nextPutAll: s printString, ' '].
		str cr.
		str nextPutAll: 'New failures: '.
		diff second do: [:s| str nextPutAll: s printString, ' '].
		str cr.
		
		str nextPutAll: 'New errors: '.
		diff third do: [:s| str nextPutAll: s printString, ' '].
		str cr].
	
	Workspace new contents: string; openLabel: 'SUnit Progress'
	! !

!TestRunner methodsFor: 'history saving' stamp: 'stephane.ducasse 10/12/2008 19:24'!
showHistoryMenu
	| selectionIndex selectedPreviousResult actionIndex |
	selectionIndex := UIManager default chooseFrom: self historyMenuList title: 'History:'.

	"We pressed outside the menu"
	selectionIndex isZero ifTrue: [ ^ self ]. 				

	"save current result is selected"
	selectionIndex = 1 ifTrue: [ self previousRun addFirst: result. ^ self ]. 			

	selectedPreviousResult := self previousRun at: (selectionIndex - 1).
 	actionIndex := (UIManager default chooseFrom: #('delete' 'show diff')  title:  'Action:').
	actionIndex = 1 ifTrue: [ self previousRun remove: selectedPreviousResult. ^ self ].
	actionIndex = 2 ifTrue: [ self showDiffWith: selectedPreviousResult].	! !

!TestRunner methodsFor: 'history saving' stamp: 'simon.denier 11/13/2008 17:02'!
showProgress
	| testCaseClasses d t string |
	testCaseClasses := (self suiteAll tests collect: [:testCase | testCase class]) asSet.
	
	"At the end of the algorithm, d will contains all the diff between what was saved and the current result"
	d := Dictionary new.
	d at: #passed put: OrderedCollection new.
	d at: #failures put: OrderedCollection new.
	d at: #errors put: OrderedCollection new.

	testCaseClasses do: [ :cls |
		(cls class methodDict includesKey: #lastStoredRun)
			ifTrue: [t := cls lastStoredRun.
					(t at: #passed) do: [:s | 	
											(result isErrorFor: cls selector: s)
												ifTrue: [(d at: #errors) add: {cls . s}].
											(result isFailureFor: cls selector: s)
												ifTrue: [(d at: #failures) add: {cls . s}]  ].
											
					(t at: #failures) do: [:s | (result isPassedFor: cls selector: s)
												ifTrue: [(d at: #passed) add: {cls . s}].
											(result isErrorFor: cls selector: s)
												ifTrue: [(d at: #errors) add: {cls . s}]].
											
					(t at: #errors) do: [:s | 	(result isPassedFor: cls selector: s)
												ifTrue: [(d at: #passed) add: {cls . s}].
											(result isFailureFor: cls selector: s)
												ifTrue: [(d at: #failures) add: {cls . s}]]]].
		
			
	string := String streamContents: [:str|
		str nextPutAll: '----------------'; cr.
		str nextPutAll: 'Diff between current result and saved result'; cr.
		str nextPutAll: 'New passed: '.
		(d at: #passed) do: [:s| str nextPutAll: s printString, ' '].
		str cr.
		str nextPutAll: 'New failures: '.
		(d at: #failures) do: [:s| str nextPutAll: s printString, ' '].
		str cr.
		
		str nextPutAll: 'New errors: '.
		(d at: #errors) do: [:s| str nextPutAll: s printString, ' '].
		str cr].
	
	Workspace new contents: string; openLabel: 'SUnit Progress' string.

	! !

!TestRunner methodsFor: 'history saving' stamp: 'simon.denier 11/13/2008 20:28'!
storeResultIntoTestCases

	result classesTested do: [:testCaseCls | testCaseCls generateLastStoredRunMethod ]
! !

TestRunner removeSelector: #browseReferencedClasses!
TestRunner removeSelector: #browseSentMessages!
TestRunner removeSelector: #browseTestClasses!
Object subclass: #TestRunner
	instanceVariableNames: 'categories categoriesSelected classes classIndex classesSelected failedList failedSelected errorList errorSelected lastUpdate result previousRun'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnitGUI'!
